/**
 * Created by Administrator on 2017/7/3.
 */
var authorize_code = '';
var user_id = '';
var access_token = '';
function SDK_Type() {
    this.INIT = 'init';
    this.LOGIN = 'login';
    this.USER_INFO = "user_info"
    this.SWITCH_ACCOUNT = 'switch_account';
    this.PAY = 'pay';
}

/**
 * 调用 android SDK 初始化 接口
 */
function onInit() {
    android.onInit(1, "onCallback");
}

/**
 * 调用 android SDK 登录 接口
 */
function onLogin() {
    android.onLogin();
}

/**
 * 调用 android SDK 二次验证 接口
 * ( 此处只提供给Demo 使用 , 正确的做法请查看服务器端文档 请求 获取用户信息接口 )
 */
function getUserInfo() {
    android.getUserInfo(authorize_code);
}

/**
 * 调用 android SDK 回传二次验证数据 接口
 * ( 主要 必须要回传 user_id 和 access_token 否则会导致 SDK 某些功能不能使用 )
 */
function onLoginRsp() {
    // json 方式组合 user_id 和 access_token
    var info = {
        'user_id'       : user_id,      // 二次验证返回的 UserID
        "access_token"  : access_token, // 二次验证返回的 Token
    };
    android.onLoginRsp(JSON.stringify(info));
}

/**
 * 调用 android SDK 上报角色信息 接口
 */
function onLoginRoleInfo() {
    // 创建 角色信息 JSON
    var user_info = {
        'uid'       : "test_uid",       // 用户UserID
        "role_id"   : "test_role_id",   // 角色 ID
        "role_name" : "test_role_name", // 角色名称
        "role_level": 1,                // 角色等级
        "server_id" : 1                 // 服务器ID
    };
    android.onLoginRoleInfo(JSON.stringify(user_info));
}

/**
 * 调用 android SDK 上报角色升级 接口
 */
function onUpdateRoleInfo() {
    // 创建 角色信息 JSON
    var user_info = {
        'uid'       : "test_uid",       // 用户UserID
        "role_id"   : "test_role_id",   // 角色 ID
        "role_name" : "test_role_name", // 角色名称
        "role_level": 1,                // 角色等级
        "server_id" : 1                 // 服务器ID
    };
    android.onUpdateRoleInfo(JSON.stringify(user_info));
}

/**
 * 调用 android SDK 支付 接口
 */
function onPay() {
    // 创建 订单信息 JSON
    var order_info = {
        'cp_order_id'   : (new Date()).valueOf(),   // CP 订单号
        "role_id"       : "test_role_id",           // 角色 ID
        "role_name"     : "test_role_name",         // 角色名称
        "server_id"     : 1,                        // 服务器 ID
        "amount"        : 1,                        // 金额 (单位为 : 分)
        "rate"          : 10,                       // 兑换比率 (默认为: 10)
        "product_desc"  : "购买1个测试商品",          // 商品描述
        "product_id"    : 1,                        // 商品ID
        "product_name"  : "1元宝",                   // 商品名称
        "notify_url"    : "http://www.test.com"     // 回调地址
    };
    android.onPay(JSON.stringify(order_info));
}

/**
 * 调用 android SDK 退出游戏 接口
 */
function onExit() {
    android.onExit();
}

/**
 * 调用 android SDK 跳转游戏链接 接口
 */
function onOpneGameUrl() {
    android.onOpenGameUrl();
}


/**
 * 接收回调的 函数
 * @param data 返回的 json 数据
 */
function onCallback(callback_type, callback_data) {
    var type = new SDK_Type();
    var data = eval('(' + callback_data + ')');
    var ret = data["ret"];  // 状态码
    var msg = data["msg"];  // 返回信息

    switch(callback_type) {
        case type.INIT:
            if(ret == 1) {
                alert("初始化成功");
            }else {
                alert("初始化失败");
            }
            break;
        case type.LOGIN:
            if(ret == 1) {
                authorize_code = data["authorize_code"];
                alert("登录成功 \n authorize_code : " + authorize_code);
            }else if(ret == 2) {
                alert("登录取消");
            }else {
                alert("登录失败");
            }
            break;
        case type.SWITCH_ACCOUNT:
            if(ret == 1) {
                authorize_code = data["authorize_code"];
                alert("切换账号登录成功 \n authorize_code : " + authorize_code);
            }else if(ret == 2) {
                alert("切换账号登录取消");
            }else {
                alert("切换账号登录失败");
            }
            break;
        case type.USER_INFO:
            if(ret == 1) {
                user_id = data["user_id"];
                access_token = data["access_token"];
                alert("二次验证成功 \n user_id : " + user_id + "\n access_token : " + access_token);
            }else {
                alert("二次验证失败");
            }
            break;
        case type.PAY:
            if(ret == 1) {
                // 支付成功
            }else if(ret == 2) {
                // 支付取消
            }else {
                // 支付失败
            }
            break;
        default:
    }
}